summaryrefslogtreecommitdiff
path: root/init-tools.sh
diff options
context:
space:
mode:
authorWes Haggard <Wes.Haggard@microsoft.com>2017-10-24 16:36:03 -0700
committerWes Haggard <Wes.Haggard@microsoft.com>2017-10-30 13:05:18 -0700
commitf75e211ded5c832611f140c0f4ed710425c73772 (patch)
treeaa08168c14a4994f2818f7095be8ea2eef6d44ea /init-tools.sh
parente65f405f21e468384277417517d78c58b2112162 (diff)
downloadcoreclr-f75e211ded5c832611f140c0f4ed710425c73772.tar.gz
coreclr-f75e211ded5c832611f140c0f4ed710425c73772.tar.bz2
coreclr-f75e211ded5c832611f140c0f4ed710425c73772.zip
Align init-tools scripts with other source-build repos
Diffstat (limited to 'init-tools.sh')
-rwxr-xr-xinit-tools.sh217
1 files changed, 103 insertions, 114 deletions
diff --git a/init-tools.sh b/init-tools.sh
index f712514262..7da424f286 100755
--- a/init-tools.sh
+++ b/init-tools.sh
@@ -12,145 +12,134 @@ __BUILD_TOOLS_PACKAGE_VERSION=$(cat $__scriptpath/BuildToolsVersion.txt)
__DOTNET_TOOLS_VERSION=$(cat $__scriptpath/DotnetCLIVersion.txt)
__BUILD_TOOLS_PATH=$__PACKAGES_DIR/microsoft.dotnet.buildtools/$__BUILD_TOOLS_PACKAGE_VERSION/lib
__INIT_TOOLS_RESTORE_PROJECT=$__scriptpath/init-tools.msbuild
-__INIT_TOOLS_DONE_MARKER_DIR=$__TOOLRUNTIME_DIR/$__BUILD_TOOLS_PACKAGE_VERSION
-__INIT_TOOLS_DONE_MARKER=$__INIT_TOOLS_DONE_MARKER_DIR/done
+__BUILD_TOOLS_SEMAPHORE=$__TOOLRUNTIME_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/init-tools.complete
-if [ -z "$__DOTNET_PKG" ]; then
- if [ "$(uname -m | grep "i[3456]86")" = "i686" ]; then
- echo "Error: build not supported on 32 bit Unix"
+if [ -e $__BUILD_TOOLS_SEMAPHORE ]; then
+ echo "Tools are already initialized"
+ return #return instead of exit because this script is inlined in other scripts which we don't want to exit
+fi
+
+if [ -e $__TOOLRUNTIME_DIR ]; then rm -rf -- $__TOOLRUNTIME_DIR; fi
+
+if [ -d "$DotNetBuildToolsDir" ]; then
+ echo "Using tools from '$DotNetBuildToolsDir'."
+ ln -s "$DotNetBuildToolsDir" "$__TOOLRUNTIME_DIR"
+
+ if [ ! -e "$__DOTNET_CMD" ]; then
+ echo "ERROR: Ensure that $DotNetBuildToolsDir contains the .NET Core SDK at $__DOTNET_PATH"
exit 1
fi
+ echo "Done initializing tools."
+ mkdir -p "$(dirname "$__BUILD_TOOLS_SEMAPHORE")" && touch $__BUILD_TOOLS_SEMAPHORE
+ return #return instead of exit because this script is inlined in other scripts which we don't want to exit
+fi
+
+echo "Running: $__scriptpath/init-tools.sh" > $__init_tools_log
+
+display_error_message()
+{
+ echo "Please check the detailed log that follows." 1>&2
+ cat "$__init_tools_log" 1>&2
+}
+
+if [ ! -e $__DOTNET_PATH ]; then
+ if [ -z "$__DOTNET_PKG" ]; then
+ if [ "$(uname -m | grep "i[3456]86")" = "i686" ]; then
+ echo "Warning: build not supported on 32 bit Unix"
+ fi
+
__PKG_ARCH=x64
- OSName=$(uname -s)
- case $OSName in
- Darwin)
- OS=OSX
+ OSName=$(uname -s)
+ case $OSName in
+ Darwin)
+ OS=OSX
__PKG_RID=osx
- ulimit -n 2048
- # Format x.y.z as single integer with three digits for each part
- VERSION=`sw_vers -productVersion| sed -e 's/\./ /g' | xargs printf "%03d%03d%03d"`
- if [ "$VERSION" -lt 010012000 ]; then
- echo error: macOS version `sw_vers -productVersion` is too old. 10.12 is needed as minimum.
- exit 1
- fi
- ;;
-
- Linux)
+ ulimit -n 2048
+ # Format x.y.z as single integer with three digits for each part
+ VERSION=`sw_vers -productVersion| sed -e 's/\./ /g' | xargs printf "%03d%03d%03d"`
+ if [ "$VERSION" -lt 010012000 ]; then
+ echo error: macOS version `sw_vers -productVersion` is too old. 10.12 is needed as minimum.
+ exit 1
+ fi
+ ;;
+
+ Linux)
__PKG_RID=linux
- OS=Linux
+ OS=Linux
- if [ -e /etc/os-release ]; then
- source /etc/os-release
- if [[ $ID == "alpine" ]]; then
- # remove the last version digit
- VERSION_ID=${VERSION_ID%.*}
+ if [ -e /etc/os-release ]; then
+ source /etc/os-release
+ if [[ $ID == "alpine" ]]; then
+ # remove the last version digit
+ VERSION_ID=${VERSION_ID%.*}
__PKG_RID=alpine.$VERSION_ID
- fi
-
- elif [ -e /etc/redhat-release ]; then
- redhatRelease=$(</etc/redhat-release)
- if [[ $redhatRelease == "CentOS release 6."* || $redhatRelease == "Red Hat Enterprise Linux Server release 6."* ]]; then
+ fi
+ elif [ -e /etc/redhat-release ]; then
+ redhatRelease=$(</etc/redhat-release)
+ if [[ $redhatRelease == "CentOS release 6."* || $redhatRelease == "Red Hat Enterprise Linux Server release 6."* ]]; then
__PKG_RID=rhel.6
+ fi
fi
- fi
- ;;
+ ;;
- *)
+ *)
echo "Unsupported OS '$OSName' detected. Downloading linux-$__PKG_ARCH tools."
- OS=Linux
+ OS=Linux
__PKG_RID=linux
- ;;
- esac
-
+ ;;
+ esac
__DOTNET_PKG=dotnet-sdk-${__DOTNET_TOOLS_VERSION}-$__PKG_RID-$__PKG_ARCH
-fi
-
-display_error_message()
-{
- echo "Please check the detailed log that follows." 1>&2
- cat "$__init_tools_log" 1>&2
-}
-
-if [ ! -e $__INIT_TOOLS_DONE_MARKER ]; then
- __PATCH_CLI_NUGET_FRAMEWORKS=0
-
- if [ -e $__TOOLRUNTIME_DIR ]; then rm -rf -- $__TOOLRUNTIME_DIR; fi
- echo "Running: $__scriptpath/init-tools.sh" > $__init_tools_log
-
- if [ ! -e $__DOTNET_PATH ]; then
-
- mkdir -p "$__DOTNET_PATH"
+ fi
+ mkdir -p "$__DOTNET_PATH"
- if [ -n "$DOTNET_TOOLSET_DIR" ] && [ -d "$DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION" ]; then
- echo "Copying $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION to $__DOTNET_PATH" >> $__init_tools_log
- cp -r $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION/* $__DOTNET_PATH
- elif [ -n "$DOTNET_TOOL_DIR" ] && [ -d "$DOTNET_TOOL_DIR" ]; then
- echo "Copying $DOTNET_TOOL_DIR to $__DOTNET_PATH" >> $__init_tools_log
- cp -r $DOTNET_TOOL_DIR/* $__DOTNET_PATH
- else
- echo "Installing dotnet cli..."
+ echo "Installing dotnet cli..."
__DOTNET_LOCATION="https://dotnetcli.azureedge.net/dotnet/Sdk/${__DOTNET_TOOLS_VERSION}/${__DOTNET_PKG}.tar.gz"
- # curl has HTTPS CA trust-issues less often than wget, so lets try that first.
- echo "Installing '${__DOTNET_LOCATION}' to '$__DOTNET_PATH/dotnet.tar'" >> $__init_tools_log
- if command -v curl > /dev/null; then
- curl --retry 10 -sSL --create-dirs -o $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
- else
- wget -q -O $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
- fi
- cd $__DOTNET_PATH
- tar -xf $__DOTNET_PATH/dotnet.tar
-
- cd $__scriptpath
-
- __PATCH_CLI_NUGET_FRAMEWORKS=1
- fi
+ # curl has HTTPS CA trust-issues less often than wget, so lets try that first.
+ echo "Installing '${__DOTNET_LOCATION}' to '$__DOTNET_PATH/dotnet.tar'" >> $__init_tools_log
+ if command -v curl > /dev/null; then
+ curl --retry 10 -sSL --create-dirs -o $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
+ else
+ wget -q -O $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
fi
+ cd $__DOTNET_PATH
+ tar -xf $__DOTNET_PATH/dotnet.tar
+ cd $__scriptpath
+fi
- if [ -n "$BUILD_TOOLS_TOOLSET_DIR" ] && [ -d "$BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION" ]; then
- echo "Copying $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION to $__TOOLRUNTIME_DIR" >> $__init_tools_log
- cp -r $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/* $__TOOLRUNTIME_DIR
- elif [ -n "$BUILD_TOOLS_TOOL_DIR" ] && [ -d "$BUILD_TOOLS_TOOL_DIR" ]; then
- echo "Copying $BUILD_TOOLS_TOOL_DIR to $__TOOLRUNTIME_DIR" >> $__init_tools_log
- cp -r $BUILD_TOOLS_TOOL_DIR/* $__TOOLRUNTIME_DIR
- else
- if [ ! -e $__BUILD_TOOLS_PATH ]; then
- echo "Restoring BuildTools version $__BUILD_TOOLS_PACKAGE_VERSION..."
- echo "Running: $__DOTNET_CMD restore \"$__INIT_TOOLS_RESTORE_PROJECT\" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION" >> $__init_tools_log
- $__DOTNET_CMD restore "$__INIT_TOOLS_RESTORE_PROJECT" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION >> $__init_tools_log
- if [ ! -e "$__BUILD_TOOLS_PATH/init-tools.sh" ]; then
- echo "ERROR: Could not restore build tools correctly." 1>&2
- display_error_message
- fi
- fi
+if [ ! -e $__BUILD_TOOLS_PATH ]; then
+ echo "Restoring BuildTools version $__BUILD_TOOLS_PACKAGE_VERSION..."
+ echo "Running: $__DOTNET_CMD restore \"$__INIT_TOOLS_RESTORE_PROJECT\" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION" >> $__init_tools_log
+ $__DOTNET_CMD restore "$__INIT_TOOLS_RESTORE_PROJECT" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION >> $__init_tools_log
+ if [ ! -e "$__BUILD_TOOLS_PATH/init-tools.sh" ]; then
+ echo "ERROR: Could not restore build tools correctly." 1>&2
+ display_error_message
+ fi
+fi
- echo "Initializing BuildTools..."
- echo "Running: $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR" >> $__init_tools_log
+echo "Initializing BuildTools..."
+echo "Running: $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR" >> $__init_tools_log
- # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
- chmod +x $__BUILD_TOOLS_PATH/init-tools.sh
- $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR >> $__init_tools_log
- if [ "$?" != "0" ]; then
- echo "ERROR: An error occurred when trying to initialize the tools." 1>&2
- display_error_message
- exit 1
- fi
- fi
+# Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
+chmod +x $__BUILD_TOOLS_PATH/init-tools.sh
+$__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR >> $__init_tools_log
+if [ "$?" != "0" ]; then
+ echo "ERROR: An error occurred when trying to initialize the tools." 1>&2
+ display_error_message
+ exit 1
+fi
- echo "Making all .sh files executable under Tools."
- # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
- ls $__scriptpath/Tools/*.sh | xargs chmod +x
- ls $__scriptpath/Tools/scripts/docker/*.sh | xargs chmod +x
+echo "Making all .sh files executable under Tools."
+# Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
+ls $__scriptpath/Tools/*.sh | xargs chmod +x
+ls $__scriptpath/Tools/scripts/docker/*.sh | xargs chmod +x
- Tools/crossgen.sh $__scriptpath/Tools
+Tools/crossgen.sh $__scriptpath/Tools
- mkdir -p $__INIT_TOOLS_DONE_MARKER_DIR
- touch $__INIT_TOOLS_DONE_MARKER
+mkdir -p "$(dirname "$__BUILD_TOOLS_SEMAPHORE")" && touch $__BUILD_TOOLS_SEMAPHORE
+
+echo "Done initializing tools."
- echo "Done initializing tools."
-else
- echo "Tools are already initialized"
-fi \ No newline at end of file